''' The Nature of Code
 Daniel Shiffman
Python Version Peter Farrell
1/16/17'''

from random import randint

w = 8 #width of cell

class Game:
    def __init__(self):
        self.cols = 600/w #replace numbers by dimensions of screen
        self.rows = 600/w 
        #create board of 0's and 1's
        self.board = [[randint(0,1) for i in range(self.cols)] for j in range(self.rows)]
        
    def generate(self):
        self.next = [[0 for i in range(self.cols)] for j in range(self.rows)]
        #loop through board and check neighbors
        for x in range(1,self.cols-1):
            for y in range(1,self.rows-1):
                neighbors = 0
                for i in range(-1,2):
                    for j in range(-1,2):
                        neighbors += self.board[x+i][y+j]
                #take out number for self
                neighbors -= self.board[x][y]
                
                #rules of Life
                if self.board[x][y] == 1 and neighbors < 2: self.next[x][y] = 0
                elif self.board[x][y] == 1 and neighbors > 3: self.next[x][y] = 0
                elif self.board[x][y] == 0 and neighbors == 3: self.next[x][y] = 1
                else: self.next[x][y] = self.board[x][y]
        
        #board is next
        self.board = self.next
             
    def display(self):
        for i in range(self.cols):
            for j in range(self.rows):
                if self.board[i][j] == 1:
                    fill(0)
                else:
                    fill(255)
                stroke(0)
                rect(i*w,j*w, w,w)

########End of Game Class##################

#create game object
gol = Game()

def setup():
    size(600, 600)
    frameRate(24)

def draw():
    background(255) #white
    gol.generate()
    gol.display()